<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { request } from '@/lib/request';
import { ref, computed, inject } from 'vue';
import { useI18n } from 'vue-i18n';
import { useRoute } from 'vue-router';

const route = useRoute();
const { t } = useI18n();
const $t = t;

let configuration = inject<any>('configuration');
const showThrubber = ref(true);
const state = ref('');

document.title = $t("exportPage.general.default.title");

const getTitle = computed(() => {
    if (state.value == "success") {
        return $t("exportPage.general.success.title");
    } else if (state.value == "fail") {
        return $t("exportPage.general.fail.title");
    } else {
        return $t("exportPage.general.default.title");
    }
});

const getSubtitle = computed(() => {
    if (state.value == "success") {
        return $t("exportPage.general.success.subtitle");
    } else if (state.value == "fail") {
        return $t("exportPage.general.fail.subtitle");
    } else {
        return $t("exportPage.general.default.subtitle");
    }
});

const getInformation = computed(() => {
    if (state.value == "success") {
        return $t("exportPage.general.success.information");
    } else if (state.value == "fail") {
        return $t("exportPage.general.fail.information");
    } else {
        return $t("exportPage.general.default.information");
    }
});

const downloadFile = async () => {
    const params = route.query;
    let paneId = params.paneid;
    let panetype = params.panetype;
    let chatId = params.chatid;
    let userId = params.userid;
    let type = params.type;
    let size = params.size;
    let layout = params.layout;
    let comments = params.comments;
    let url = configuration.exportServer + (paneId?`/api/export/${panetype}/${paneId}`:`/api/export/chat/${chatId}${userId?"/"+userId:""}`);
    if (type === "pdf") url += `/pdf?size=${size}&layout=${layout}&comments=${comments}`;
    try {
        let response = await request('GET', url, '', '', true);
        if (response) {
            const url = window.URL.createObjectURL(response);
            const link = document.createElement('a');
            link.href = url;
            if (type === "png")
                link.setAttribute('download', 'export.png');
            else if (type === "pdf")
                link.setAttribute('download', 'export.pdf');
            document.body.appendChild(link);
            link.click();
            state.value = "success";
            document.title = $t("exportPage.general.success.title");
        }
    } catch (error) {
        console.error(error)
        state.value = "fail";
        document.title = $t("exportPage.general.fail.title");
    }
    showThrubber.value = false;
};

downloadFile();

</script>
<template>
    <div class="h-screen w-screen bg-gray-100">
        <div class="flex flex-row justify-center h-full">
            <div class="m-auto box-border rounded-lg shadow-md bg-white max-w-[700px]">
                <div class="text-center p-8 flex flex-col gap-1">
                    <h2 class="text-2xl" :class="[{ 'text-red-600': state === 'fail' }]">{{ getTitle }}</h2>
                    <h3 class="text-lg" :class="[{ 'text-red-600': state === 'fail' }]">{{ getSubtitle }}</h3>
                    <p class="text-gray-500" :class="[{ 'text-red-600': state === 'fail' }]">{{ getInformation }}</p>
                    <div class="w-full flex justify-center overflow-hidden" v-if="showThrubber">
                        <svg class="animate-spin h-20 w-20 text-accent1-default" xmlns="http://www.w3.org/2000/svg" fill="none"
                            viewBox="0 0 24 24">
                            <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="2"></circle>
                            <path class="opacity-100" fill="currentColor"
                                d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z">
                            </path>
                        </svg>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>